#include <bits/stdc++.h>

using namespace std;

int b[100010];

int main() 
{
    long long n,m,sum=0,c;
    
    cin >> n;
    cin >> m;
    
    int a[n];
    
    int c1[n];
    
    for(int i=1; i<=m; i++)
    {
        cin >> b[i];
    }
    
    cin >> c;
    
    for(int i=1; i<=n; i++)
    {
        a[i]=i;
        if(i==1)
        {
            c1[i]=c;
        }
        else
        {
            c1[i]=c1[i-1]*c;
        }
    }
    
    for(int i=0; i<=n-m; i++)
    {
        for(int j=1; j<=m; j++)
        {
            a[i+b[j]]=a[i+j];
        }
    }
    
    for(int i=1; i<=n; i++)
    {
        sum+=(c1[i]*a[i]);
    }

    cout << sum%998244353 << endl;
    
    return 0;
}